CoCoA-5 - Design #364

Incr command/function
03 Jun 2013 16:23 - John Abbott

Status: Closed Start date: 03 Jun 2013
Priority: Normal Due date:

Assignee: John Abbott % Done: 100%
Category: Parser/Interpreter Estimated time: 1.00 hour
Target version: CoCoA-5.0.9 Spent time: 1.25 hour

Description
I would like to have a command for incrementing a counter; and probably another for decrementing.

So instead of writing

IterCounter := IterCounter+l;

one could simply write

incr IterCounter;

What names should the commands have? incr and decr, or maybe increment and decrement.
The command could insist that the value to be incremented is an integer (o/w error).
The following CoCoA fn could achieve most of what | have in mind:
Define incr (ref N)
If Type(N) <> INT Then error ("incr: value must be integer"); EndIf;

N := N+1;
EndDefine;

Maybe we should add the function (secretly?); and consider adding a command only if the function proves to be too slow?

Comments? Opinions?

Related issues:

Related to CoCoA-5 - Feature #504: New operators: += -= *= /= In Progress 02 Apr 2014
Related to CoCoA-5 - Feature #518: incr/decr functions: to be used in packages Closed 03 Apr 2014
Related to CoCoA-5 - Slug #1275: incr and decr are slow New 29 Apr 2019
History

#1 - 13 Jun 2013 15:31 - Anna Maria Bigatti
- Category set to Parser/Interpreter

- Target version set to CoCoA-5.1.0 Easter14
#2 - 25 Mar 2014 18:03 - John Abbott

- Status changed from New to Resolved

- Assignee set to John Abbott
- Target version changed from CoCoA-5.1.0 Easter14 to CoCoA-5.0.9
- % Done changed from 0 to 50

Placing defns of incr and decr in NotBuiltin.
JAA will add doc.

#3 - 26 Mar 2014 16:14 - John Abbott
- Status changed from Resolved to Feedback

- % Done changed from 50 to 90

Written documentation.

The only negative aspect is that the user must write ref before the arg;
if we define commands then ref will no longer be needed.

#4 - 02 Apr 2014 01:17 - John Abbott

Using fgrep "+1;" *.cpkg5 produced about 30 lines which could be modified to use incr or decr.

Let's try in one file, and compare before and after to see what we think.
[not now, it's too late!]

#5 - 02 Apr 2014 14:38 - Anna Maria Bigatti

- Subject changed from Incr command to Incr command/function

#6 - 02 Apr 2014 18:35 - Anna Maria Bigatti
- Estimated time set to 1.00 h

#7 - 03 Apr 2014 20:20 - Anna Maria Bigatti
- Status changed from Feedback to Closed

- % Done changed from 90 to 100

John Abbott wrote:

Using fgrep "+1;" *.cpkg5 produced about 30 lines which could be modified to use incr or decr.

Let's try in one file, and compare before and after to see what we think.
[not now, it's too late!]

Made new issue #518 for applying incr in packages.
Closing this one for 5.0.9
https://cocoa.dima.unige.it/redmine/issues/518

#8 - 29 Apr 2019 17:53 - John Abbott
- Related to Slug #1275: incr and decr are slow added
